/*
 * 03-9999.c
 */

#include <stdio.h>
#include "s_print.h"
#include "s_input.h"

/*
 *
 */

typedef struct {
		int x;
		int y;
} Point2D;

typedef struct {
		int x;
		int y;
		int z;
} Point3D;

/*
 * 複数の整数を書式指定して文字列の中に埋め込む 
 */

void myprintf ( char *msg, ... ) {
  int i;
  char *pvalue = (char *)&msg + sizeof( char * );
  Point2D p2v;
  Point3D p3v;

  for ( i = 0; msg[i] != EOS; i++ ) { /* 一文字ずつ処理 */
	if ( msg[i] == '%' ) {		/* 文字列の中に '%' があったら特別処理する */
	  i++; 						/* 次の文字をみる */
	  switch ( msg[i] ) {
	  case 'd':					/* 10 進数 */
		s_print_int ( *((int *)pvalue) );
		pvalue += sizeof ( int );
		break;
	  case 'o':					/* 8 進数 */
		s_print_int ( *((int *)pvalue) );
		pvalue += sizeof ( int );
		break;
	  case 'x':					/* 16 進数 */
		s_print_int ( *((int *)pvalue) );
		pvalue += sizeof ( int );
		break;
	  case 'c':					/* 文字 */
		s_print_char ( *((char *)pvalue) );
		pvalue += sizeof ( int );	/* char は自動的に int にされる */
		break;
	  case 's':					/* 文字列 */
		s_print_string ( *((char **)pvalue) );
		pvalue += sizeof ( char * );
		break;
	  case 'f':					/* 浮動小数点数 */
		s_print_double ( *((double *)pvalue) );
		pvalue += sizeof ( double );
		break;
	  case 'D':					/* Point2D 型 */
		p2v = *((Point2D *)pvalue);
			/* p2v の値を (%d,%d) の形式で出力する */
		myprintf ( "(%d,%d)", p2v.x, p2v.y );
			/* 次のデータを処理するために pvalue 変更 */
		pvalue += sizeof ( Point2D );
		break;
	  case 'T':					/* Point3D 型 */

	/*
	**	 この部分を完成させなさい
	*/

		break;
	  case '%':					/* '%' が重なったら.. */
		s_print_char ( '%' );	/* '%' を出力 */
		break;
	  default:					/* その他 : よくわからないので読み飛ばす.. */
		  break;
	  }
	} else {	/* そうでなけれ .. */
	  s_print_char ( msg[i] );	/* そのままその文字を出力 */
	}
  }
}

/*
 * 色々な数値の出力
 */

int main ( void ) {
	Point3D pv;


	/*
	**	 この部分を完成させなさい
	*/


  /*
   * データの出力 (Output)
   */

  myprintf ( "点の座標 : %T\n", pv );

  /*
   * 
   */

  return 0;
}

/*
 *
 */

